//----------------------------------------------------------------------------------------------

// PasteJob.h

//----------------------------------------------------------------------------------------------

#pragma once

#import <Cocoa/Cocoa.h>

class PasteJob {
public:
  PasteJob(DWindow *TheWndw);

private:
  void AppendToOurList(PDObject TheObj);
  bool GetScale(NSDictionary *TheDict,double &theScale) const;
  //bool GetGlobalOrigin(NSDictionary *TheDict,CDPoint &theOrigin) const;
  //bool GetInsertionPoint(NSDictionary *TheDict,CDPoint &thePt) const;
  
  //bool GetLayerName(NSDictionary *TheNSLayer,NSString *TheLayerName) const;
  //bool GetLayerColor(NSDictionary *TheNSLayer,RGBColor &TheLayerColor) const;
  //bool GetLayerScale(NSDictionary *TheNSLayer,double &TheLayerScale) const;
  
  //CDPoint CorrectPoint(CDPoint ThePt) const;
  
  bool Get2DPoint(NSArray *Points,long theIndex,CDPoint &thePt) const;
  
  //bool GetAColor(NSDictionary *TheColor,RGBColor &TheRGBColor,double &Alpha) const;
  //void GetPenColor(NSDictionary *TheObj,PDObject &ThisObj) const;
  //void GetFillColor(NSDictionary *TheObj,PDObject &ThisObj) const;
  
  //void GetLineDash(NSDictionary *TheObj,PDObject &ThisObj) const;
  //void GetPenSize(NSDictionary *TheObj,PDObject &ThisObj) const;
  
  double RotationAngle(NSDictionary *TheObj) const;
  bool GetStartAngle(NSDictionary *TheObj,double &TheAngle) const;
  bool GetArcAngle(NSDictionary *TheObj,double &TheAngle) const;
  double CornerRadius(NSDictionary *TheObj) const;
  //bool ObjectClosed(NSDictionary *TheObj) const;
  
  //bool GetArrowFromLine(NSDictionary *TheObj,CLineEndType &TheArrow) const;
  //bool GetArrowFromEllipse(NSDictionary *TheObj,CLineEndType &TheArrow) const;
  //bool GetArrowFromPolygon(NSDictionary *TheObj,CLineEndType &TheArrow) const;
  //bool GetArrowFromBezier(NSDictionary *TheObj,CLineEndType &TheArrow) const;
  
  //bool GetArrowsFromList(NSArray *TheNSList,CLineEndType &TheArrow) const;
  //void GetArrows(NSDictionary *TheObj,PDObject &ThisObj) const;
  
  void ParsePoint(NSDictionary *TheObj);
  void ParsePoint3D(NSDictionary *TheObj);
  void ParseLine(NSDictionary *TheObj);
  void ParseRectangle(NSDictionary *TheObj);
  void ParseEllipse(NSDictionary *TheObj);
  void ParsePolygonOrBSpline(short ObjType,NSDictionary *TheObj);
  void ParseBezier(NSDictionary *TheObj);
  
  void ParseTheAdvancedList(NSArray *TheNSList,bool &FoundObj);
  void ParseTheList(NSArray *TheNSList);
  void ParseTheLayers(NSArray *TheNSLayerList);

public:    
  void ReadTheDictionary(NSDictionary *TheDocument);
  void ReadOpenClipFile(void);

private:  
  DWindow             *mTheWndw;
  //double               mPgSzY;
  double               mSourceScale;
  double               mDestScale;
  double               mScaleFactor;  // Source to Dest. mSourceScale / mDestScale;
  long                 mNbrFound;
  ListRecord           mTheList;
};